searchNodes=[{"doc":"Multiverses suite to enable isolated HTTP communications over multiverse shards How to Use In your Phoenix endpoint: defmodule MyAppWeb.Endpoint do #... if Mix . env ( ) == :test do plug Multiverses.Plug end #... end Warning If you anticipate needing to recompile the Endpoint module on the fly you will need a better way to store the build environment, as the Mix module may not be available to the running VM. In your test (assuming the Multiverses.Req adapter is used) declare that your test shards over the Http multiverses name domain. alias Multiverses.Req instead of using the Req module. defmodule MyAppTest do alias Multiverses.Req @port #.... setup do Multiverses . shard ( Http ) end test &quot;some test&quot; do result = Req . get ( &quot;localhost: \#{ @port } &quot; ) assert result = #... end end How it works The adapters for the http clients inject the Multiverses.shard/1 id into the http header x-multiverse-id . This is then intercepted by the Multiverses.Plug module plug in your Endpoint, which then performs a lookup to obtain the :$callers for the request; this :$callers chain is then added to the request process dictionary for the duration of the http Plug pipeline. Because this exchange installs :$callers a side effect is that other services that are :$callers aware, such as Mox or Ecto will be able to see their respective checkouts. Cluster awareness Multiverses.Http is tested to work over a BEAM cluster. If you spin up a cluster as a part of your tests, you can issue an http request to a node that is not the node running ExUnit and the :$callers for the request will be remote pids (relative to the request handlers). Before proceeding with clustered tests, check to see if the modules that depend on this (e.g. Mox , Ecto ) are able to correctly route their sandbox checkouts to the correct node in the cluster. Other backends Currently there is support only for the Req client library. If support for other libraries is desired, please issue a PR. Compilation of library adapters will be gated on the :http_clients application environment variable, which is currently set to [Req] .","ref":"Multiverses.Http.html","title":"Multiverses.Http","type":"module"},{"doc":"finds the current process' Multiverses shard ( Http ) id and looks up the associated :$callers chain. This chain is then imported into as the current process' :$callers chain. Generally you would only want to call this function if you are writing a non- Plug http handler or a websocket server. In such a case you should call this function immediately after associating the current process with the shard using Multiverses.allow/3 or Multiverses.allow/2 .","ref":"Multiverses.Http.html#adopt_callers/1","title":"Multiverses.Http.adopt_callers/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Multiverses.Http.html#child_spec/1","title":"Multiverses.Http.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Multiverses.Http.html#init/1","title":"Multiverses.Http.init/1","type":"function"},{"doc":"obtains the Multiverses shard ( Http ) id and registers the current calling process :$callers stack, if it has not already been registered. Generally you would only want to call this function if you are implementing an adapter for an HTTP or websocket client library.","ref":"Multiverses.Http.html#registered_id/0","title":"Multiverses.Http.registered_id/0","type":"function"},{"doc":"","ref":"Multiverses.Http.html#start_link/1","title":"Multiverses.Http.start_link/1","type":"function"},{"doc":"A module Plug that intercepts an http request and temporarily assigns the callers stack of the http request to the Http shard stored in the x-multiverse-id header of the http request","ref":"Multiverses.Plug.html","title":"Multiverses.Plug","type":"module"},{"doc":"Callback implementation for Plug.call/2 .","ref":"Multiverses.Plug.html#call/2","title":"Multiverses.Plug.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1 .","ref":"Multiverses.Plug.html#init/1","title":"Multiverses.Plug.init/1","type":"function"},{"doc":"Multiverses shim for the Req library. Implements all functions found in the Req module, replacing request , delete , get , head , patch , post , and put (and related functions) with their Multiverses equivalent. Must be used in tandem with Multiverses.Plug","ref":"Multiverses.Req.html","title":"Multiverses.Req","type":"module"},{"doc":"See Req.default_options/0 .","ref":"Multiverses.Req.html#default_options/0","title":"Multiverses.Req.default_options/0","type":"function"},{"doc":"See Req.default_options/1 .","ref":"Multiverses.Req.html#default_options/1","title":"Multiverses.Req.default_options/1","type":"function"},{"doc":"see Req.delete/2","ref":"Multiverses.Req.html#delete/2","title":"Multiverses.Req.delete/2","type":"function"},{"doc":"see Req.delete!/2","ref":"Multiverses.Req.html#delete!/2","title":"Multiverses.Req.delete!/2","type":"function"},{"doc":"see Req.get/2","ref":"Multiverses.Req.html#get/2","title":"Multiverses.Req.get/2","type":"function"},{"doc":"see Req.get!/2","ref":"Multiverses.Req.html#get!/2","title":"Multiverses.Req.get!/2","type":"function"},{"doc":"see Req.head/2","ref":"Multiverses.Req.html#head/2","title":"Multiverses.Req.head/2","type":"function"},{"doc":"see Req.head!/2","ref":"Multiverses.Req.html#head!/2","title":"Multiverses.Req.head!/2","type":"function"},{"doc":"See Req.new/0 .","ref":"Multiverses.Req.html#new/0","title":"Multiverses.Req.new/0","type":"function"},{"doc":"See Req.new/1 .","ref":"Multiverses.Req.html#new/1","title":"Multiverses.Req.new/1","type":"function"},{"doc":"see Req.patch/2","ref":"Multiverses.Req.html#patch/2","title":"Multiverses.Req.patch/2","type":"function"},{"doc":"see Req.patch!/2","ref":"Multiverses.Req.html#patch!/2","title":"Multiverses.Req.patch!/2","type":"function"},{"doc":"see Req.post/2","ref":"Multiverses.Req.html#post/2","title":"Multiverses.Req.post/2","type":"function"},{"doc":"see Req.post!/2","ref":"Multiverses.Req.html#post!/2","title":"Multiverses.Req.post!/2","type":"function"},{"doc":"see Req.put/2","ref":"Multiverses.Req.html#put/2","title":"Multiverses.Req.put/2","type":"function"},{"doc":"see Req.put!/2","ref":"Multiverses.Req.html#put!/2","title":"Multiverses.Req.put!/2","type":"function"},{"doc":"","ref":"Multiverses.Req.html#request/1","title":"Multiverses.Req.request/1","type":"function"},{"doc":"","ref":"Multiverses.Req.html#request/2","title":"Multiverses.Req.request/2","type":"function"},{"doc":"See Req.request/3 .","ref":"Multiverses.Req.html#request/3","title":"Multiverses.Req.request/3","type":"function"},{"doc":"","ref":"Multiverses.Req.html#request!/1","title":"Multiverses.Req.request!/1","type":"function"},{"doc":"","ref":"Multiverses.Req.html#request!/2","title":"Multiverses.Req.request!/2","type":"function"},{"doc":"","ref":"readme.html","title":"Multiverses.Http","type":"extras"},{"doc":"This package can be installed by adding multiverses_http to your list of dependencies in mix.exs : def deps do [ { :multiverses , &quot;~&gt; 0.9&quot; , runtime : ( Mix . env == :test ) } , { :multiverses_http , &quot;~&gt; 0.1.0&quot; , runtime : ( Mix . env == :test ) } ] end Documentation can be found at https://hexdocs.pm/multiverses_http .","ref":"readme.html#installation","title":"Multiverses.Http - Installation","type":"extras"}]